## flash3kyuu-deband-dmo 2.0.0.1

=== msvc/wscript ===
from waflib import Logs
from waflib import Options


def configure(conf):
    conf.load("python")
    conf.check_python_version((3, 0, 0))

    Logs.info("Will use msbuild to compile")
    conf.find_program("msbuild", path_list=conf.env.PATH, var="MSBUILD")
    conf.env.MSBUILD = '\"%s\"' % (conf.env.MSBUILD,)

    if conf.options.mode not in ("debug", "release", "release_msvc"):
        conf.fatal("--mode must be either debug, release or release_msvc.")

    conf.env.BUILD_CONFIGURATION = conf.options.mode
    if conf.env.DEST_CPU == "x86":
        conf.env.TARGET_PLATFORM = "Win32"
    elif conf.env.DEST_CPU == "amd64":
        conf.env.TARGET_PLATFORM = "x64"
    else:
        conf.fatal("Unsupported target CPU: " + conf.env.DEST_CPU)

    conf.msg("Target platform", conf.env.TARGET_PLATFORM)

    conf.env.ENABLE_TEST = conf.options.test
    conf.msg_feature("Tests", conf.env.ENABLE_TEST)
    conf.env.ENABLE_AVISYNTH = conf.options.avisynth
    conf.msg_feature("Avisynth support", conf.env.ENABLE_AVISYNTH)


def build(bld):
    Options.options.jobs = 1 # Don't run multiple jobs at the same time
    int_dir = bld.path.get_bld().make_node(r"tmp")
    final_output_dir = bld.path.get_bld().parent
    bld.env.INTDIR = int_dir.abspath()
    libs = [("SHARED", "DynamicLibrary", ".dll"),
            ("STATIC", "StaticLibrary", ".lib")]
    bld.env.DISABLE_VAPOURSYNTH = str(not bld.env.ENABLE_VAPOURSYNTH).lower()
    bld.env.DISABLE_AVISYNTH = str(not bld.env.ENABLE_AVISYNTH).lower()
    for var, type, ext in libs:
        if not bld.env[var]:
            continue

        output_name = bld.env.APPNAME + ext
        int_output_dir = int_dir.find_or_declare(var.lower())
        int_output = int_output_dir.find_or_declare(output_name)
        msbuild_params = (
            r"/t:Build "
            r"/p:OutDir=" + int_output_dir.abspath() + r"\ "
            r"/p:Configuration=${BUILD_CONFIGURATION} "
            r"/p:Platform=${TARGET_PLATFORM} "
            r"/p:DisableVapoursynth=${DISABLE_VAPOURSYNTH} "
            r"/p:DisableAvisynth=${DISABLE_AVISYNTH} "
            r"/p:BuildProjectReferences=false "
            r"/p:DisableProjectReferences=true "
        )
        bld(
            rule=(
                "${MSBUILD} ${SRC[0].abspath()} "
                r"/p:TargetName=${APPNAME} "
                r"/p:IntDir=${INTDIR}\obj\ "
                r"/p:ConfigurationType=" + type + " "
                + msbuild_params
            ),
            source=bld.path.find_resource("flash3kyuu_deband.vcxproj"),
            target=int_output,
            always=True,
            update_outputs=True,
        )
        bld(
            rule="copy \"${SRC}\" \"${TGT}\"",
            source=int_output,
            target=final_output_dir.find_or_declare(output_name),
        )

    if bld.env.ENABLE_TEST:
        test_output_name = bld.env.APPNAME + "-test.exe"
        test_int_output = int_output_dir.find_or_declare(test_output_name)
        bld(
            rule=(
                "${MSBUILD} ${SRC[0].abspath()} "
                r"/p:TargetName=${APPNAME}-test "
                r"/p:IntDir=${INTDIR}\obj\test\ "
                r"/p:AdditionalDependencies=${APPNAME}.lib "
                + ("/p:StaticF3kdb=true " if type == "StaticLibrary" else "")
                + msbuild_params
            ),
            source=[
                bld.path.find_resource("f3kdb_test.vcxproj"),
                int_output,
            ],
            target=test_int_output,
            always=True,
            update_outputs=True,
        )
        bld(
            rule="copy \"${SRC}\" \"${TGT}\"",
            source=test_int_output,
            target=final_output_dir.find_or_declare(test_output_name),
        )

=== test/wscript ===
import os

from waflib import Utils, Build
from waflib.TaskGen import feature, before_method, after_method
from waflib.Task import compile_fun


def options(opt):
    opt.load("compiler_c")
    opt.add_option("--enable-test", action="store_true", default=False,
                   dest="test", help="build tests")
    opt.add_option("--disable-test", action="store_false",
                   dest="test", help="do not build tests (default)")


def configure(conf):
    conf.msg_feature("Tests", conf.options.test)
    if not conf.options.test:
        return

    conf.env.BUILD_TEST = True
    conf.load("compiler_c")
    conf.find_program("cmake", var="CMAKE")
    conf.find_program("make", var="MAKE")

    if conf.env.STATIC and conf.env.DEST_OS_NORMALIZED == "windows":
        lib_param_name = "stlib"
    else:
        lib_param_name = "lib"

    if not any(conf.check_cxx(
                   uselib_store="PTHREAD",
                   mandatory=False,
                   **{lib_param_name: x}
               )
               for x in ["pthreads", "pthread"]):
        conf.fatal("Can't find pthread.")

    googletest_dir = Utils.subst_vars("${VENDORLIBS}/googletest", conf.env)
    if not os.path.isfile(os.path.join(googletest_dir, "CMakeLists.txt")):
        conf.fatal("Can't find Google Test, please run 'git submodule update --init --recursive' to update git submodules")

    conf.env.GTEST_ROOT = googletest_dir


@feature('static')
@after_method('apply_link')
def make_fully_static(self):
    assert self.link_task
    self.link_task.hcode += " -Wl,-Bstatic"
    func, _ = compile_fun(self.link_task.hcode)
    self.link_task.run = lambda: func(self.link_task)

@feature('static')
@before_method('apply_link')
def make_fully_static_before(self):
    self.env.append_unique("LINKFLAGS", ["-static"])


def build(bld):
    if not bld.env.BUILD_TEST:
        return

    bld.post_mode = Build.POST_BOTH

    bld.add_group()
    gtest_build = bld.path.get_bld().make_node("gtest")
    gtest_build.mkdir()

    makefile = gtest_build.make_node("Makefile")
    cmakelists = bld.root.find_node(bld.env.GTEST_ROOT + "/CMakeLists.txt")
    bld(
        rule="CXX=${CXX} CC=${CC} ${CMAKE} ${GTEST_ROOT}",
        source=cmakelists,
        target=makefile,
        cwd=gtest_build.abspath(),
    )
    gtest_output = [gtest_build.make_node(x)
                    for x in ("libgtest.a", "libgtest_main.a")]
    bld(
        name="gtest",
        rule="${MAKE}",
        source=makefile,
        target=gtest_output,
        cwd=gtest_build.abspath(),
    )
    bld(
        rule="${PYTHON3} ${SRC[0].abspath()} > ${TGT[0].abspath()}",
        source="build_core_param_set.py",
        target=bld.path.find_node("test_core_param_set.h"),
        cwd=bld.path.abspath(),
    )
    bld.add_group()
    test_output = bld.path.get_bld().make_node("f3kdb-test")
    bld(
        features="cxx cxxprogram %s" % ((
            "static" if
            bld.env.STATIC and bld.env.DEST_OS_NORMALIZED == "windows"
            else ""
        ),),
        source=bld.path.ant_glob(
            ["*.cpp"],
            excl=[
                "stdafx.cpp",
            ],
        ),
        includes=[Utils.subst_vars("${GTEST_ROOT}/include", bld.env)],
        use=["f3kdb", "gtest"],
        uselib=["PTHREAD"],
        stlib=["gtest", "gtest_main"],
        stlibpath=[gtest_build.abspath()],
        linkflags="-Wl,-rpath={}:.:..".format(
            bld.path.get_bld().parent.abspath()
        ),
        target=test_output,
    )
    [bld.add_manual_dependency(test_output, x) for x in gtest_output]

=== debian/changelog ===
flash3kyuu-deband-dmo (2.0.0.1-dmo2) unstable; urgency=medium

  * Should Depends on vapoursynth

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 11 Apr 2019 10:11:02 +0200

flash3kyuu-deband-dmo (2.0.0.1-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Jun 2017 17:27:07 +0200

=== debian/control ===
Source: flash3kyuu-deband-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/SAPikachu/flash3kyuu_deband
Standards-Version: 4.3.0
Build-Depends: debhelper-compat (= 12), python, vapoursynth-dev

Package: vapoursynth-flash3kyuu-deband
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vapoursynth
Description: deband filter for vapoursynth
 It works by replacing banded pixels with average value of referenced
 pixels, and optionally add grain (random dithering) to them.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./waf configure --prefix=/usr \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/vapoursynth

override_dh_auto_build:
	./waf build

override_dh_auto_install:
	./waf install --destdir=debian/vapoursynth-flash3kyuu-deband

	$(RM) -rf debian/vapoursynth-flash3kyuu-deband/usr/include

override_dh_auto_clean:
	./waf distclean

override_dh_installchangelogs:
	dh_installchangelogs docs/source/change_log.rst

=== debian/watch ===
version=4

https://github.com/SAPikachu/flash3kyuu_deband/releases \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
